#include <memory>
#include "windows.h"

template<typename _Ty>
	class MyHeapAlloc
	{	// generic allocator for objects of class _Ty
public:
	typedef _SIZT size_type;
	typedef _PDFT difference_type;
	typedef _Ty _FARQ *pointer;
	typedef const _Ty _FARQ *const_pointer;
	typedef _Ty _FARQ& reference;
	typedef const _Ty _FARQ& const_reference;
	typedef _Ty value_type;

	template<typename _Other>
		struct rebind
		{	// convert an allocator<_Ty> to an allocator <_Other>
		typedef MyHeapAlloc<_Other> other;
		};

	pointer address(reference _Val) const
		{	// return address of mutable _Val
		return (&_Val);
		}

	const_pointer address(const_reference _Val) const
		{	// return address of nonmutable _Val
		return (&_Val);
		}
private:
	MyHeapAlloc()
		{	// construct default allocator (do nothing)
		}
    HANDLE m_hHeap;
    template <class U> friend class MyHeapAlloc;
public:

	MyHeapAlloc( HANDLE hHeap )
    	: m_hHeap( hHeap )
		{
		}

	MyHeapAlloc(const MyHeapAlloc<_Ty>& rhs )
	    : m_hHeap( rhs.m_hHeap )
		{
		}

	template<typename _Other>
		MyHeapAlloc(const MyHeapAlloc<_Other>& rhs)
		: m_hHeap( rhs.m_hHeap )
		{
		}

	template<typename _Other>
		MyHeapAlloc<_Ty>& operator=(const MyHeapAlloc<_Other>& rhs)
		: m_hHeap( rhs.m_hHeap )
		{
		return (*this);
		}

	pointer allocate(size_type _Count, const void *)
		{
		    return pointer( HeapAlloc( m_hHeap, 0, _Count * sizeof(_Ty) ) );
		}

	pointer allocate(size_type _Count)
		{
		    return pointer( HeapAlloc( m_hHeap, 0, _Count * sizeof(_Ty) ) );
		}

	void deallocate(pointer _Ptr, size_type)
		{
		    HeapFree( m_hHeap, 0, _Ptr );
		}

	void construct(pointer _Ptr, const _Ty& _Val)
		{	// construct object at _Ptr with value _Val
		std::_Construct(_Ptr, _Val);
		}

	void destroy(pointer _Ptr)
		{	// destroy object at _Ptr
		std::_Destroy(_Ptr);
		}

	_SIZT max_size() const
		{	// estimate maximum array size
		_SIZT _Count = (_SIZT)(-1) / sizeof (_Ty);
		return (0 < _Count ? _Count : 1);
		}
	};
