#include <memory>

template<typename _Ty>
    class InPlaceAlloc
    {   // generic allocator for objects of class _Ty
public:
    typedef _SIZT size_type;
    typedef _PDFT difference_type;
    typedef _Ty _FARQ *pointer;
    typedef const _Ty _FARQ *const_pointer;
    typedef _Ty _FARQ& reference;
    typedef const _Ty _FARQ& const_reference;
    typedef _Ty value_type;

    template<typename _Other>
        struct rebind
        {   // convert an allocator<_Ty> to an allocator <_Other>
        typedef InPlaceAlloc<_Other> other;
        };

    pointer address(reference _Val) const
        {   // return address of mutable _Val
        return (&_Val);
        }

    const_pointer address(const_reference _Val) const
        {   // return address of nonmutable _Val
        return (&_Val);
        }

   InPlaceAlloc( void* pBuffer, size_t nBytes )
      :
      m_pBuffer( static_cast<unsigned char*>( pBuffer ) ),
      m_nMaxBytes( nBytes ),
      m_nBytesAllocated( 0 )
   {
   }

    InPlaceAlloc(const InPlaceAlloc<_Ty>&)
        {   // construct by copying (do nothing)
        }

    template<typename _Other>
        InPlaceAlloc(const InPlaceAlloc<_Other>&)
        {   // construct from a related allocator (do nothing)
        }

    template<typename _Other>
        InPlaceAlloc<_Ty>& operator=(const InPlaceAlloc<_Other>&)
        {   // assign from a related allocator (do nothing)
        return (*this);
        }

    pointer allocate(size_type _Count, const void *)
        {
        // very fast
        pointer p = pointer( m_pBuffer + m_nBytesAllocated );
        m_nBytesAllocated += ( _Count * sizeof(_Ty) );
        return p;
        }

    pointer allocate(size_type _Count)
        {
        // very fast
        pointer p = pointer( m_pBuffer + m_nBytesAllocated );
        m_nBytesAllocated += ( _Count * sizeof(_Ty) );
        return p;
        }

    void deallocate(pointer , size_type)
        {
        }

    void construct(pointer _Ptr, const _Ty& _Val)
        {   // construct object at _Ptr with value _Val
        std::_Construct(_Ptr, _Val);
        }

    void destroy(pointer _Ptr)
        {   // destroy object at _Ptr
        std::_Destroy(_Ptr);
        }

    _SIZT max_size() const
        {   // estimate maximum array size
        _SIZT _Count = (_SIZT)(-1) / sizeof (_Ty);
        return (0 < _Count ? _Count : 1);
        }

private:

   unsigned char* m_pBuffer;
   size_t m_nMaxBytes;
   size_t m_nBytesAllocated;
   
    InPlaceAlloc()
        {   // construct default allocator (do nothing)
        }
    template <class U> friend class InPlaceAlloc;
   

    };

